diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/tx-duration-test.cc ns-3.45/src/wifi/test/tx-duration-test.cc
--- ns-3.44/src/wifi/test/tx-duration-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -1944,220 +2589,692 @@
 
     AddTestCase(new PhyHeaderSectionsTest, TestCase::Duration::QUICK);
 
-    // 20 MHz band, HeSigBDurationTest::OFDMA, even number of users per HE-SIG-B content channel
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_106_TONE, 1, true}, 11, 1}, {{HeRu::RU_106_TONE, 2, true}, 10, 4}},
+    const auto p80OrLow80 = true;
+    const auto s80OrHigh80 = false;
+    for (const auto p160 :
+         std::initializer_list<std::optional<bool>>{std::nullopt /* HE-SIG-B */,
+                                                    std::optional(true) /* EHT-SIG */})
+    {
+        // 20 MHz band, OFDMA, even number of users in content channel
+        AddTestCase(
+            new MuSigDurationTest({{MakeRuSpec(RuType::RU_106_TONE, 1, p80OrLow80, p160), 11, 1},
+                                   {MakeRuSpec(RuType::RU_106_TONE, 2, p80OrLow80, p160), 10, 4}},
+                                  VhtPhy::GetVhtMcs5(),
+                                  MHz_u{20},
+                                  0,
+                                  MuSigDurationTest::OFDMA,
+                                  (p160 == std::nullopt) ? RuAllocation{96} : RuAllocation{48},
+                                  std::make_pair(2, 0), // both users in content channel 1
+                                  MicroSeconds(4)),     // one OFDM symbol;
+            TestCase::Duration::QUICK);
+
+        // 40 MHz band, OFDMA, even number of users per content channel
+        AddTestCase(new MuSigDurationTest(
+                        {{MakeRuSpec(RuType::RU_106_TONE, 1, p80OrLow80, p160), 11, 1}, // CC1
+                         {MakeRuSpec(RuType::RU_106_TONE, 2, p80OrLow80, p160), 10, 4}, // CC1
+                         {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 4, 1},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 6, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 7, p80OrLow80, p160), 5, 3},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 8, p80OrLow80, p160), 6, 2}},  // CC2
+                        VhtPhy::GetVhtMcs4(),
+                        MHz_u{40},
+                        0,
+                        MuSigDurationTest::OFDMA,
+                        (p160 == std::nullopt) ? RuAllocation{96, 112} : RuAllocation{48, 24},
+                        std::make_pair(2, 4), // two users in content channel 1 and
+                                              // four users in content channel 2
+                        MicroSeconds(4)),     // one OFDM symbol;
+                    TestCase::Duration::QUICK);
+
+        // 40 MHz band, OFDMA, odd number of users in second content channel
+        AddTestCase(new MuSigDurationTest(
+                        {{MakeRuSpec(RuType::RU_106_TONE, 1, p80OrLow80, p160), 11, 1}, // CC1
+                         {MakeRuSpec(RuType::RU_106_TONE, 2, p80OrLow80, p160), 10, 4}, // CC1
+                         {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 4, 1},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 6, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 7, p80OrLow80, p160), 5, 3},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 8, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 14, p80OrLow80, p160), 3, 1}}, // CC2
+                        VhtPhy::GetVhtMcs3(),
+                        MHz_u{40},
+                        0,
+                        MuSigDurationTest::OFDMA,
+                        (p160 == std::nullopt) ? RuAllocation{96, 15} : RuAllocation{48, 15},
+                        std::make_pair(2, 5), // two users in content channel 1 and
+                                              // five users in content channel 2
+                        MicroSeconds(8)),     // two OFDM symbols
+                    TestCase::Duration::QUICK);
+
+        // 80 MHz band, OFDMA
+        AddTestCase(new MuSigDurationTest(
+                        {{MakeRuSpec(RuType::RU_106_TONE, 1, p80OrLow80, p160), 11, 1}, // CC1
+                         {MakeRuSpec(RuType::RU_106_TONE, 2, p80OrLow80, p160), 10, 4}, // CC1
+                         {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 4, 1},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 6, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 7, p80OrLow80, p160), 5, 3},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 8, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 14, p80OrLow80, p160), 3, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_242_TONE, 3, p80OrLow80, p160), 1, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_242_TONE, 4, p80OrLow80, p160), 4, 1}}, // CC2
+                        VhtPhy::GetVhtMcs1(),
+                        MHz_u{80},
+                        0,
+                        MuSigDurationTest::OFDMA,
+                        (p160 == std::nullopt) ? RuAllocation{96, 15, 192, 192}
+                                               : RuAllocation{48, 15, 64, 64},
+                        std::make_pair(3, 6), // three users in content channel 1
+                                              // and six users in content channel 2
+                        MicroSeconds(16)),    // four OFDM symbols
+                    TestCase::Duration::QUICK);
+
+        // 80 MHz band, OFDMA, no central 26-tones RU
+        AddTestCase(new MuSigDurationTest(
+                        {{MakeRuSpec(RuType::RU_26_TONE, 1, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 2, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 3, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 4, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 5, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 6, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 7, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 8, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 9, p80OrLow80, p160), 8, 1},   // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 10, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 11, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 12, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 13, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 14, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 15, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 16, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 17, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 18, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 20, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 21, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 22, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 23, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 24, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 25, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 26, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 27, p80OrLow80, p160), 8, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_26_TONE, 28, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 29, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 30, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 31, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 32, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 33, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 34, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 35, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 36, p80OrLow80, p160), 8, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 37, p80OrLow80, p160), 8, 1}}, // CC2
+                        VhtPhy::GetVhtMcs5(),
+                        MHz_u{80},
+                        0,
+                        MuSigDurationTest::OFDMA,
+                        {0, 0, 0, 0},
+                        std::make_pair(18, 18), // 18 users users in each content channel
+                        MicroSeconds(12)),      // three OFDM symbols
+                    TestCase::Duration::QUICK);
+
+        // 160 MHz band, OFDMA, no central 26-tones RU
+        AddTestCase(new MuSigDurationTest(
+                        {{MakeRuSpec(RuType::RU_106_TONE, 1, p80OrLow80, p160), 11, 1}, // CC1
+                         {MakeRuSpec(RuType::RU_106_TONE, 2, p80OrLow80, p160), 10, 4}, // CC1
+                         {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 4, 1},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 6, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 7, p80OrLow80, p160), 5, 3},   // CC2
+                         {MakeRuSpec(RuType::RU_52_TONE, 8, p80OrLow80, p160), 6, 2},   // CC2
+                         {MakeRuSpec(RuType::RU_26_TONE, 14, p80OrLow80, p160), 3, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_242_TONE, 3, p80OrLow80, p160), 1, 1},  // CC1
+                         {MakeRuSpec(RuType::RU_242_TONE, 4, p80OrLow80, p160), 4, 1},  // CC2
+                         {MakeRuSpec(RuType::RU_996_TONE, 1, s80OrHigh80, p160),
+                          1,
+                          1}}, // CC1 or CC2 => CC1 for better split
+                        VhtPhy::GetVhtMcs1(),
+                        MHz_u{160},
+                        0,
+                        MuSigDurationTest::OFDMA,
+                        (p160 == std::nullopt) ? RuAllocation{96, 15, 192, 192, 208, 115, 208, 115}
+                                               : RuAllocation{48, 15, 64, 64, 80, 30, 80, 30},
+                        std::make_pair(4, 6), // four users in content channel 1 and
+                                              // seven users in content channel 2
+                        MicroSeconds(16)),    // four OFDM symbols
+                    TestCase::Duration::QUICK);
+
+        // 20 MHz band, OFDMA, one unallocated RU at the middle
+        AddTestCase(
+            new MuSigDurationTest(
+                {{MakeRuSpec(RuType::RU_26_TONE, 1, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 2, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 3, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 4, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 6, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 7, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 8, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_26_TONE, 9, p80OrLow80, p160), 11, 1}}, // CC1
+                VhtPhy::GetVhtMcs5(),
+                MHz_u{20},
+                0,
+                MuSigDurationTest::OFDMA,
+                {0},
+                std::make_pair(9, 0), // 9 users (8 users + 1 empty user) in content channel 1
+                MicroSeconds(8)),     // two OFDM symbols
+            TestCase::Duration::QUICK);
+
+        // 40 MHz band, OFDMA, unallocated RUs at the begin and at the end of the
+        // first 20 MHz subband and in the middle of the second 20 MHz subband
+        AddTestCase(
+            new MuSigDurationTest(
+                {{MakeRuSpec(RuType::RU_52_TONE, 2, p80OrLow80, p160), 10, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_52_TONE, 3, p80OrLow80, p160), 10, 2},  // CC1
+                 {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 11, 1},  // CC2
+                 {MakeRuSpec(RuType::RU_52_TONE, 8, p80OrLow80, p160), 11, 2}}, // CC2
+                VhtPhy::GetVhtMcs5(),
+                MHz_u{40},
+                0,
+                MuSigDurationTest::OFDMA,
+                (p160 == std::nullopt) ? RuAllocation{112, 112} : RuAllocation{24, 24},
+                std::make_pair(4,
+                               4), // 4 users (2 users + 2 empty users) in each content channel
+                MicroSeconds(4)),  // one OFDM symbol
+            TestCase::Duration::QUICK);
+
+        // 40 MHz band, OFDMA, one unallocated RUs in the first 20 MHz subband and
+        // two unallocated RUs in second 20 MHz subband
+        AddTestCase(
+            new MuSigDurationTest(
+                {{MakeRuSpec(RuType::RU_52_TONE, 1, p80OrLow80, p160), 10, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_52_TONE, 2, p80OrLow80, p160), 10, 2},  // CC1
+                 {MakeRuSpec(RuType::RU_52_TONE, 3, p80OrLow80, p160), 11, 1},  // CC1
+                 {MakeRuSpec(RuType::RU_52_TONE, 5, p80OrLow80, p160), 11, 2},  // CC2
+                 {MakeRuSpec(RuType::RU_52_TONE, 6, p80OrLow80, p160), 11, 3}}, // CC2
+                VhtPhy::GetVhtMcs5(),
+                MHz_u{40},
+                0,
+                MuSigDurationTest::OFDMA,
+                (p160 == std::nullopt) ? RuAllocation{112, 112} : RuAllocation{24, 24},
+                std::make_pair(4,
+                               4), // 4 users (3 users + 1 empty user) in content channel 1 and
+                                   // 4 users (2 users + 2 empty users) in content channel 2
+                MicroSeconds(4)),  // one OFDM symbol
+            TestCase::Duration::QUICK);
+    }
+
+    // 80 MHz band, OFDMA, central 26-tones RU (11ax only)
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_26_TONE, 1, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 2, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 3, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 4, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 5, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 6, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 7, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 8, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 9, true}, 8, 1},   // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 10, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 11, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 12, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 13, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 14, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 15, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 16, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 17, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 18, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 19, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 20, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 21, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 22, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 23, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 24, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 25, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 26, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 27, true}, 8, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 28, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 29, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 30, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 31, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 32, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 33, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 34, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 35, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 36, true}, 8, 1},  // CC2
+                     {HeRu::RuSpec{RuType::RU_26_TONE, 37, true}, 8, 1}}, // CC2
                     VhtPhy::GetVhtMcs5(),
-                    MHz_u{20},
-                    HeSigBDurationTest::OFDMA,
-                    {96},
-                    std::make_pair(2, 0), // both users in HE-SIG-B content channel 1
-                    MicroSeconds(4)),     // one OFDM symbol;
+                    MHz_u{80},
+                    0,
+                    MuSigDurationTest::OFDMA,
+                    {0, 0, 0, 0},
+                    std::make_pair(19,
+                                   18), // 19 users (18 users + 1 central tones-RU user) in content
+                                        // channel 1 and 18 users user in content channel 2
+                    MicroSeconds(12)),  // three OFDM symbols
                 TestCase::Duration::QUICK);
 
-    // 40 MHz band, HeSigBDurationTest::OFDMA, even number of users per HE-SIG-B content channel
-    AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_106_TONE, 1, true}, 11, 1},
-                                {{HeRu::RU_106_TONE, 2, true}, 10, 4},
-                                {{HeRu::RU_52_TONE, 5, true}, 4, 1},
-                                {{HeRu::RU_52_TONE, 6, true}, 6, 2},
-                                {{HeRu::RU_52_TONE, 7, true}, 5, 3},
-                                {{HeRu::RU_52_TONE, 8, true}, 6, 2}},
-                               VhtPhy::GetVhtMcs4(),
-                               MHz_u{40},
-                               HeSigBDurationTest::OFDMA,
-                               {96, 112},
-                               std::make_pair(2, 4), // two users in HE-SIG-B content channel 1 and
-                                                     // four users in HE-SIG-B content channel 2
-                               MicroSeconds(4)),     // one OFDM symbol;
-        TestCase::Duration::QUICK);
+    // 160 MHz band, OFDMA, central 26-tones RU in low 80 MHz (11ax only)
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_106_TONE, 1, true}, 11, 1}, // CC1
+                                       {HeRu::RuSpec{RuType::RU_106_TONE, 2, true}, 10, 4}, // CC1
+                                       {HeRu::RuSpec{RuType::RU_52_TONE, 5, true}, 4, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_52_TONE, 6, true}, 6, 2},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_52_TONE, 7, true}, 5, 3},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_52_TONE, 8, true}, 6, 2},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 14, true}, 3, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 19, true}, 8, 2},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 3, true}, 1, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 4, true}, 4, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_996_TONE, 1, false},
+                                        1,
+                                        1}}, // CC1 or CC2 => CC1 for better split
+                                      VhtPhy::GetVhtMcs1(),
+                                      MHz_u{160},
+                                      0,
+                                      MuSigDurationTest::OFDMA,
+                                      {96, 15, 192, 192, 208, 115, 208, 115},
+                                      std::make_pair(5, 6), // five users in content channel 1 and
+                                                            // seven users in content channel 2
+                                      MicroSeconds(16)),    // four OFDM symbols
+                TestCase::Duration::QUICK);
 
-    // 40 MHz band, HeSigBDurationTest::OFDMA, odd number of users per HE-SIG-B content channel
+    // 160 MHz band, OFDMA, central 26-tones RU in high 80 MHz (11ax only)
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_106_TONE, 1, true}, 11, 1},
-                                {{HeRu::RU_106_TONE, 2, true}, 10, 4},
-                                {{HeRu::RU_52_TONE, 5, true}, 4, 1},
-                                {{HeRu::RU_52_TONE, 6, true}, 6, 2},
-                                {{HeRu::RU_52_TONE, 7, true}, 5, 3},
-                                {{HeRu::RU_52_TONE, 8, true}, 6, 2},
-                                {{HeRu::RU_26_TONE, 14, true}, 3, 1}},
-                               VhtPhy::GetVhtMcs3(),
-                               MHz_u{40},
-                               HeSigBDurationTest::OFDMA,
-                               {96, 15},
-                               std::make_pair(2, 5), // two users in HE-SIG-B content channel 1 and
-                                                     // five users in HE-SIG-B content channel 2
-                               MicroSeconds(8)),     // two OFDM symbols
+        new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_106_TONE, 1, true}, 11, 1},  // CC1
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 2, true}, 10, 4},  // CC1
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 3, true}, 11, 1},  // CC2
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 4, true}, 10, 4},  // CC2
+                               {HeRu::RuSpec{RuType::RU_242_TONE, 3, true}, 10, 1},  // CC1
+                               {HeRu::RuSpec{RuType::RU_242_TONE, 4, true}, 11, 1},  // CC2
+                               {HeRu::RuSpec{RuType::RU_484_TONE, 1, false}, 7, 1},  // CC1 or CC2
+                               {HeRu::RuSpec{RuType::RU_26_TONE, 19, false}, 8, 2},  // CC2
+                               {HeRu::RuSpec{RuType::RU_484_TONE, 2, false}, 9, 1}}, // CC1 or CC2
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{160},
+                              0,
+                              MuSigDurationTest::OFDMA,
+                              {96, 96, 192, 192, 200, 114, 114, 200},
+                              std::make_pair(4, 5), // two users in content channel 1 and
+                                                    // one user in content channel 2
+                              MicroSeconds(4)),     // two OFDM symbols
         TestCase::Duration::QUICK);
 
-    // 80 MHz band, OFDMA
+    // 160 MHz band, OFDMA, central 26-tones RU in both 80 MHz (11ax only)
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_106_TONE, 1, true}, 11, 1},
-                                {{HeRu::RU_106_TONE, 2, true}, 10, 4},
-                                {{HeRu::RU_52_TONE, 5, true}, 4, 1},
-                                {{HeRu::RU_52_TONE, 6, true}, 6, 2},
-                                {{HeRu::RU_52_TONE, 7, true}, 5, 3},
-                                {{HeRu::RU_52_TONE, 8, true}, 6, 2},
-                                {{HeRu::RU_26_TONE, 14, true}, 3, 1},
-                                {{HeRu::RU_242_TONE, 3, true}, 1, 1},
-                                {{HeRu::RU_242_TONE, 4, true}, 4, 1}},
-                               VhtPhy::GetVhtMcs1(),
-                               MHz_u{80},
-                               HeSigBDurationTest::OFDMA,
-                               {96, 15, 192, 192},
-                               std::make_pair(3, 6), // three users in HE-SIG-B content channel 1
-                                                     // and six users in HE-SIG-B content channel 2
-                               MicroSeconds(16)),    // four OFDM symbols
+        new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_106_TONE, 1, true}, 11, 1},  // CC1
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 2, true}, 10, 4},  // CC1
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 3, true}, 11, 1},  // CC2
+                               {HeRu::RuSpec{RuType::RU_106_TONE, 4, true}, 10, 4},  // CC2
+                               {HeRu::RuSpec{RuType::RU_26_TONE, 19, true}, 8, 2},   // CC1
+                               {HeRu::RuSpec{RuType::RU_242_TONE, 3, true}, 10, 1},  // CC1
+                               {HeRu::RuSpec{RuType::RU_242_TONE, 4, true}, 11, 1},  // CC2
+                               {HeRu::RuSpec{RuType::RU_484_TONE, 1, false}, 7, 1},  // CC1 or CC2
+                               {HeRu::RuSpec{RuType::RU_26_TONE, 19, false}, 8, 2},  // CC2
+                               {HeRu::RuSpec{RuType::RU_484_TONE, 2, false}, 9, 1}}, // CC1 or CC2
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{160},
+                              0,
+                              MuSigDurationTest::OFDMA,
+                              {96, 96, 192, 192, 200, 114, 114, 200},
+                              std::make_pair(5, 5), // two users in content channel 1 and
+                                                    // one user in content channel 2
+                              MicroSeconds(4)),     // two OFDM symbols
         TestCase::Duration::QUICK);
 
-    // 160 MHz band, OFDMA
+    // 160 MHz band, OFDMA, 11ax maximum number of users
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_26_TONE, 1, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 2, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 3, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 4, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 5, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 6, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 7, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 8, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 9, true}, 8, 1},    // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 10, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 11, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 12, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 13, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 14, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 15, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 16, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 17, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 18, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 19, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 20, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 21, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 22, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 23, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 24, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 25, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 26, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 27, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 28, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 29, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 30, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 31, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 32, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 33, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 34, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 35, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 36, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 37, true}, 8, 1},   // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 1, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 2, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 3, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 4, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 5, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 6, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 7, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 8, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 9, false}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 10, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 11, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 12, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 13, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 14, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 15, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 16, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 17, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 18, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 19, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 20, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 21, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 22, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 23, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 24, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 25, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 26, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 27, false}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 28, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 29, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 30, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 31, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 32, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 33, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 34, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 35, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 36, false}, 8, 1},  // CC2
+                                       {HeRu::RuSpec{RuType::RU_26_TONE, 37, false}, 8, 1}}, // CC2
+                                      VhtPhy::GetVhtMcs5(),
+                                      MHz_u{160},
+                                      0,
+                                      MuSigDurationTest::OFDMA,
+                                      {0, 0, 0, 0, 0, 0, 0, 0},
+                                      std::make_pair(37,
+                                                     37), // 37 users (36 users + 1 central tones-RU
+                                                          // user) in each content channel
+                                      MicroSeconds(20)),  // five OFDM symbols
+                TestCase::Duration::QUICK);
+
+    // 320 MHz band, OFDMA, 11be maximum number of users
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_106_TONE, 1, true}, 11, 1},
-                                {{HeRu::RU_106_TONE, 2, true}, 10, 4},
-                                {{HeRu::RU_52_TONE, 5, true}, 4, 1},
-                                {{HeRu::RU_52_TONE, 6, true}, 6, 2},
-                                {{HeRu::RU_52_TONE, 7, true}, 5, 3},
-                                {{HeRu::RU_52_TONE, 8, true}, 6, 2},
-                                {{HeRu::RU_26_TONE, 14, true}, 3, 1},
-                                {{HeRu::RU_242_TONE, 3, true}, 1, 1},
-                                {{HeRu::RU_242_TONE, 4, true}, 4, 1},
-                                {{HeRu::RU_996_TONE, 1, false}, 1, 1}},
-                               VhtPhy::GetVhtMcs1(),
-                               MHz_u{160},
-                               HeSigBDurationTest::OFDMA,
-                               {96, 15, 192, 192, 208, 208, 208, 208},
-                               std::make_pair(4, 7), // four users in HE-SIG-B content channel 1 and
-                                                     // seven users in HE-SIG-B content channel 2
-                               MicroSeconds(20)),    // five OFDM symbols
+        new MuSigDurationTest({{EhtRu::RuSpec{RuType::RU_26_TONE, 1, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 2, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 3, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 4, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 5, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 6, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 7, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 8, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 9, true, true}, 8, 1},     // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 10, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 11, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 12, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 13, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 14, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 15, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 16, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 17, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 18, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 20, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 21, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 22, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 23, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 24, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 25, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 26, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 27, true, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 28, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 29, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 30, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 31, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 32, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 33, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 34, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 35, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 36, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 37, true, true}, 8, 1},    // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 1, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 2, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 3, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 4, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 5, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 6, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 7, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 8, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 9, true, false}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 10, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 11, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 12, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 13, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 14, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 15, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 16, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 17, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 18, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 20, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 21, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 22, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 23, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 24, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 25, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 26, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 27, true, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 28, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 29, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 30, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 31, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 32, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 33, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 34, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 35, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 36, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 37, true, false}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 1, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 2, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 3, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 4, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 5, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 6, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 7, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 8, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 9, false, true}, 8, 1},    // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 10, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 11, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 12, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 13, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 14, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 15, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 16, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 17, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 18, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 20, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 21, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 22, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 23, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 24, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 25, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 26, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 27, false, true}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 28, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 29, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 30, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 31, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 32, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 33, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 34, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 35, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 36, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 37, false, true}, 8, 1},   // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 1, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 2, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 3, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 4, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 5, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 6, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 7, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 8, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 9, false, false}, 8, 1},   // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 10, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 11, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 12, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 13, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 14, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 15, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 16, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 17, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 18, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 20, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 21, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 22, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 23, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 24, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 25, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 26, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 27, false, false}, 8, 1},  // CC1
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 28, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 29, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 30, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 31, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 32, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 33, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 34, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 35, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 36, false, false}, 8, 1},  // CC2
+                               {EhtRu::RuSpec{RuType::RU_26_TONE, 37, false, false}, 8, 1}}, // CC2
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{320},
+                              0,
+                              MuSigDurationTest::OFDMA,
+                              {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
+                              std::make_pair(72,
+                                             72), // 72 users in each content channel
+                              MicroSeconds(40)),  // ten OFDM symbols
         TestCase::Duration::QUICK);
 
-    // 20 MHz band, HeSigBDurationTest::OFDMA, one unallocated RU at the middle
+    // 160 MHz band, OFDMA, 11ax single-user using 2x996 tones RU
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_26_TONE, 1, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 2, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 3, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 4, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 6, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 7, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 8, true}, 11, 1},
-                                {{HeRu::RU_26_TONE, 9, true}, 11, 1}},
-                               VhtPhy::GetVhtMcs5(),
-                               MHz_u{20},
-                               HeSigBDurationTest::OFDMA,
-                               {0},
-                               std::make_pair(9, 0), // 9 users in HE-SIG-B content channel 1
-                               MicroSeconds(8)),     // two OFDM symbols
+        new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_2x996_TONE, 1, true}, 8, 1}}, // CC1
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{160},
+                              0,
+                              MuSigDurationTest::OFDMA,
+                              {208, 208, 208, 208, 208, 208, 208, 208},
+                              std::make_pair(1, 0), // one user in HE-SIG-B content channel 1
+                              MicroSeconds(4)),     // one OFDM symbol;
         TestCase::Duration::QUICK);
 
-    // 40 MHz band, HeSigBDurationTest::OFDMA, unallocated RUs at the begin and at the end of the
-    // first 20 MHz subband and in the middle of the second 20 MHz subband
+    // 160 MHz band, OFDMA, 11ax with primary80 is in the high 80 MHz band
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_52_TONE, 2, true}, 10, 1},
-                                {{HeRu::RU_52_TONE, 3, true}, 10, 2},
-                                {{HeRu::RU_52_TONE, 5, true}, 11, 1},
-                                {{HeRu::RU_52_TONE, 8, true}, 11, 2}},
-                               VhtPhy::GetVhtMcs5(),
-                               MHz_u{40},
-                               HeSigBDurationTest::OFDMA,
-                               {112, 112},
-                               std::make_pair(4, 4), // 4 users in both HE-SIG-B content channels
-                               MicroSeconds(4)),     // two OFDM symbols
+        new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_996_TONE, 1, false}, 8, 1}, // CC2
+                               {HeRu::RuSpec{RuType::RU_996_TONE, 1, true}, 8, 1}}, // CC1
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{160},
+                              4,
+                              MuSigDurationTest::OFDMA,
+                              {208, 115, 208, 115, 115, 208, 115, 208},
+                              std::make_pair(1, 1), // one user in each HE-SIG-B content channel
+                              MicroSeconds(4)),     // one OFDM symbol;
         TestCase::Duration::QUICK);
 
-    // 40 MHz band, HeSigBDurationTest::OFDMA, one unallocated RUs in the first 20 MHz subband and
-    // two unallocated RUs in second 20 MHz subband
+    // 40 MHz band, OFDMA, first 20 MHz is punctured
     AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_52_TONE, 1, true}, 10, 1},
-                                {{HeRu::RU_52_TONE, 2, true}, 10, 2},
-                                {{HeRu::RU_52_TONE, 3, true}, 11, 1},
-                                {{HeRu::RU_52_TONE, 5, true}, 11, 2},
-                                {{HeRu::RU_52_TONE, 6, true}, 11, 3}},
-                               VhtPhy::GetVhtMcs5(),
-                               MHz_u{40},
-                               HeSigBDurationTest::OFDMA,
-                               {112, 112},
-                               std::make_pair(4, 4), // 4 users in both HE-SIG-B content channels
-                               MicroSeconds(4)),     // two OFDM symbols
+        new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 2, true}, 11, 1}}, // CC2
+                              VhtPhy::GetVhtMcs5(),
+                              MHz_u{40},
+                              1,
+                              MuSigDurationTest::OFDMA,
+                              {113, 192},
+                              std::make_pair(0, 1), // one user in HE-SIG-B content channel 1
+                              MicroSeconds(4)),     // one OFDM symbol;
         TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 2 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_242_TONE, 1, true}, 11, 1}, {{HeRu::RU_242_TONE, 1, true}, 10, 4}},
-                    VhtPhy::GetVhtMcs5(),
-                    MHz_u{20},
-                    HeSigBDurationTest::MU_MIMO,
-                    {192},
-                    std::make_pair(2, 0), // both users in HE-SIG-B content channel 1
-                    MicroSeconds(4)),     // one OFDM symbol
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 11, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 10, 4}}, // CC1
+                                      VhtPhy::GetVhtMcs5(),
+                                      MHz_u{20},
+                                      0,
+                                      MuSigDurationTest::MU_MIMO,
+                                      {192},
+                                      std::make_pair(2, 0), // both users in content channel 1
+                                      MicroSeconds(4)),     // one OFDM symbol
                 TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 3 users
-    AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_242_TONE, 1, true}, 4, 3},
-                                {{HeRu::RU_242_TONE, 1, true}, 5, 2},
-                                {{HeRu::RU_242_TONE, 1, true}, 6, 1}},
-                               VhtPhy::GetVhtMcs4(),
-                               MHz_u{20},
-                               HeSigBDurationTest::MU_MIMO,
-                               {192},
-                               std::make_pair(3, 0), // all users in HE-SIG-B content channel 1
-                               MicroSeconds(4)),     // one OFDM symbol
-        TestCase::Duration::QUICK);
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 4, 3},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 5, 2},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 6, 1}}, // CC1
+                                      VhtPhy::GetVhtMcs4(),
+                                      MHz_u{20},
+                                      0,
+                                      MuSigDurationTest::MU_MIMO,
+                                      {192},
+                                      std::make_pair(3, 0), // all users in content channel 1
+                                      MicroSeconds(4)),     // one OFDM symbol
+                TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 4 users
-    AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_242_TONE, 1, true}, 4, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 5, 2},
-                                {{HeRu::RU_242_TONE, 1, true}, 6, 3},
-                                {{HeRu::RU_242_TONE, 1, true}, 7, 2}},
-                               VhtPhy::GetVhtMcs4(),
-                               MHz_u{20},
-                               HeSigBDurationTest::MU_MIMO,
-                               {192},
-                               std::make_pair(4, 0), // all users in HE-SIG-B content channel 1
-                               MicroSeconds(4)),     // one OFDM symbol
-        TestCase::Duration::QUICK);
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 4, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 5, 2},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 6, 3},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 7, 2}}, // CC1
+                                      VhtPhy::GetVhtMcs4(),
+                                      MHz_u{20},
+                                      0,
+                                      MuSigDurationTest::MU_MIMO,
+                                      {192},
+                                      std::make_pair(4, 0), // all users in content channel 1
+                                      MicroSeconds(4)),     // one OFDM symbol
+                TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 6 users
-    AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_242_TONE, 1, true}, 4, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 5, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 6, 2},
-                                {{HeRu::RU_242_TONE, 1, true}, 7, 2},
-                                {{HeRu::RU_242_TONE, 1, true}, 8, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 9, 1}},
-                               VhtPhy::GetVhtMcs4(),
-                               MHz_u{20},
-                               HeSigBDurationTest::MU_MIMO,
-                               {192},
-                               std::make_pair(6, 0), // all users in HE-SIG-B content channel 1
-                               MicroSeconds(4)),     // one OFDM symbol
-        TestCase::Duration::QUICK);
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 4, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 5, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 6, 2},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 7, 2},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 8, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 9, 1}}, // CC1
+                                      VhtPhy::GetVhtMcs4(),
+                                      MHz_u{20},
+                                      0,
+                                      MuSigDurationTest::MU_MIMO,
+                                      {192},
+                                      std::make_pair(6, 0), // all users in content channel 1
+                                      MicroSeconds(4)),     // one OFDM symbol
+                TestCase::Duration::QUICK);
 
     // 20 MHz band, MU-MIMO, 8 users
-    AddTestCase(
-        new HeSigBDurationTest({{{HeRu::RU_242_TONE, 1, true}, 4, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 5, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 6, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 7, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 8, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 9, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 10, 1},
-                                {{HeRu::RU_242_TONE, 1, true}, 11, 1}},
-                               VhtPhy::GetVhtMcs4(),
-                               MHz_u{20},
-                               HeSigBDurationTest::MU_MIMO,
-                               {192},
-                               std::make_pair(8, 0), // all users in HE-SIG-B content channel 1
-                               MicroSeconds(8)),     // two OFDM symbols
-        TestCase::Duration::QUICK);
+    AddTestCase(new MuSigDurationTest({{HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 4, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 5, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 6, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 7, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 8, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 9, 1},   // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 10, 1},  // CC1
+                                       {HeRu::RuSpec{RuType::RU_242_TONE, 1, true}, 11, 1}}, // CC1
+                                      VhtPhy::GetVhtMcs4(),
+                                      MHz_u{20},
+                                      0,
+                                      MuSigDurationTest::MU_MIMO,
+                                      {192},
+                                      std::make_pair(8, 0), // all users in content channel 1
+                                      MicroSeconds(8)),     // two OFDM symbols
+                TestCase::Duration::QUICK);
 
     // 40 MHz band, MU-MIMO, 2 users
-    AddTestCase(new HeSigBDurationTest(
-                    {{{HeRu::RU_484_TONE, 1, true}, 11, 1}, {{HeRu::RU_484_TONE, 1, true}, 10, 4}},
+    AddTestCase(new MuSigDurationTest(
+                    {{HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 11, 1},  // CC1
+                     {HeRu::RuSpec{RuType::RU_484_TONE, 1, true}, 10, 4}}, // CC2
                     VhtPhy::GetVhtMcs5(),
                     MHz_u{40},
-                    HeSigBDurationTest::MU_MIMO,
+                    0,
+                    MuSigDurationTest::MU_MIMO,
                     {200, 200},
                     std::make_pair(1, 1), // users equally split between the two content channels
                     MicroSeconds(4)),     // one OFDM symbol
